
void initMeterItems(void);
unsigned long long getEpochTimeWithMs(void);

#define NUMBER_OF_METERS 6 /* the number of meters we use */

#define METER_INDEX_TST  0 /* index of the button example meter data */
#define METER_INDEX_GAS  1 /* index of the gas meter data */
#define METER_INDEX_EL1  2 /* index of the Electricity 1 meter data */
#define METER_INDEX_EL2  3 /* index of the Electricity 2 meter data */
#define METER_INDEX_AU1  4 /* index of Auxiliary input 1 */
#define METER_INDEX_AU2  5 /* index of Auxiliary input 1 */


#define METERS_INT_CHECK_INTERVAL_MS 100 /* how often (in ms) do we check if one of the I/O lines has triggered */


#define DEBOUNCE_TICK_THRESHOLD_MS 50 /* when two ticks are less than this time period apart, the second tick is ignored (debouncing) */
#define ACCUMULATE_TICK_THRESHOLD_SEC 30 /* how long (seconds) should the ticks be accumulated before a new data item is created? */

typedef struct
{
  portSHORT meterEnabled;  /* 0: item not used, 1: meter enabled */
  unsigned long long timeLastTick; /* when did the last tick occur? epoch time in seconds */
  unsigned long long timeBeforeLastTick; /* when did the tick before the last tick occur? epoch time in seconds */
  portLONG valueLastTick;   /* what value did we have at the last tick? */
  portLONG valueBeforeLastTick;   /* what value did we have at the tick before the last tick? */
  portLONG currentValue;  /* the value of the meter. gets incremented by the ISR */
} meterItem;

meterItem meterItems[NUMBER_OF_METERS]; /* the data for all the meters */

/* the history spans (SOLAR_WATT_HISTORYSIZE * SOLAR_WATT_HISTORY_STEPSIZE) / 1000 seconds */

/* how many old values of the three wattages do we keep? */
#define SOLAR_WATT_HISTORYSIZE        10
/* how far are the values apart? in milliseconds */
#define SOLAR_WATT_HISTORY_STEPSIZE   3000
extern int SolarHistory[SOLAR_WATT_HISTORYSIZE][3]; /* three watt values: P1, P2, P3 */
extern int historyRemainTime; /* how many ticks have we left until the next history entry must be written? */

